'________________________________________________________________

'USING NOTIFY ICONS, CONTEXT MENUS, & GOOGLE SEARCH STRINGS

'                                        Ron Kessler

'                                   Created 10/10/08
'________________________________________________________________

'Add a notifyicon component from the toolbox
'Add a process component from the toolbox
'Add a ContextMenuStrip from the toolbox

'Look closely at the properties for the notifyicon and menu strip to see how I made them

'When you run this app. make sure to resize VS a little so you can see the task bar. When you type
'in a search string, a little balloon will appear for about 2 secs in the System Tray and you will see
'a search icon. If you rt. click on this icon, you can exit the application. If you move the mouse over
'the icon in the tray, you will see a tooltip.

'I use a property to hold the search string instead of a class-level variable.


Public Class Form1

    Private _String2Find As String
    Private Property SearchString() As String
        Get
            Return _String2Find
        End Get
        Set(ByVal value As String)
            _String2Find = value
        End Set
    End Property


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click

        Me.SearchString = txtSearch.Text.Trim

        If Me.SearchString.Trim.Length > 0 Then

            NotifyIcon1.ShowBalloonTip(2)
            With Process1
                .StartInfo.FileName = ("http://www.google.com/search?q=" & Me.SearchString & "&rls=com.microsoft:en-us&ie=UTF-8&oe=UTF-8&startIndex=&startPage=1")
                .Start()
            End With
        End If

    End Sub


    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        If Process1 IsNot Nothing Then
            Process1.Close()
        End If

    End Sub

    Private Sub CloseAll()

        NotifyIcon1.Visible = False
        NotifyIcon1.ShowBalloonTip(0)

        '---now find all the instances of IE that are running. You can use this for any program!
        Dim theProcesses() As Process = System.Diagnostics.Process.GetProcessesByName("Iexplore")

        '---cycle through them and find the one where my search string shows up in the IE title bar
        '---I am using the Instr (InString) function. It searches a string within a string and returns an
        '   integer which indicates the first position in the string being searched where it found a match
        'If the value is >0 then it found it.

        For Each currentProcess As Process In theProcesses

            If InStr(currentProcess.MainWindowTitle.ToString, Me.SearchString) > 0 Then
                currentProcess.Kill()
            End If
        Next

        Application.Exit()

    End Sub


    Private Sub Quit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles Quit.Click, btnQuit.Click
        CloseAll()
    End Sub
End Class
